#!/usr/bin/perl
#
# Graphics Muse Page Generator:  Blog pages
#
# (c) 2002 Michael J. Hammel
#
#======================================================================

# Include the relevent perl modules
use CGI	qw/:standard :html3 :netscape/;
use Msql;
use POSIX;

require "globals.pl";
require "gettime.pl";

$PAGETITLE="Blog: ";
$WEBMASTER="webmaster";
$HTML_DIR="./templates";
$HTML_DIR2="/home/httpd/blog";

# Make sure the destination directories exist.
if ( ! -d $HTML_DIR2 )
{
	print "$HTML_DIR2 does not exist!\n";
	print "Can't generate Blog static pages.\n";
	exit 1
}

#======================================================================
# Database stuff - we do this up front.
#
# Open the Msql connections and select the databases of interest.
my $dbh1 = Msql->connect();
$dbh1->selectdb($DATABASE);

# Grab a list of users to create side bar links
$query_line = "SELECT * FROM registrations order by first";
$sth = $dbh1->query($query_line);
while (@result = $sth->fetchrow)
{
	$name = join(" ", $result[3], $result[2]);
	push @userlist, 
			font({-size=>"-1"}, 
				a({-class=>"navbar", -href=>"/blog/userlogs.pl?id=$result[0]"}, 
					b("$name") 
				)
			),
			br();
	push @userids, $result[1];
}

# Must be done after the database has been opened and user list generated!
require "header-blog.pl";

# Now buld the list of entries for the front page.
foreach (@userids)
{
	my $uid = $_;

	# Get the users latest entry
	$index=0;
	$query_lines[$index++] = "SELECT * FROM logs WHERE userid = '";
	$query_lines[$index++] = $uid;
	$query_lines[$index++] = "' ORDER BY id DESC";
	$query_line = join("", @query_lines);
	undef @query_lines;
	$sth = $dbh1->query($query_line);
	if ($sth->numrows > 0 )
	{
		@result = $sth->fetchrow;
	
		# Read the log file for that entry.
		open(FD, "$HTML_DIR2/logs/$uid/$result[4]");
		while (<FD>)
		{
			push @logfile, $_;
		}
		close(FD);
	
		# Post process it for the web page.
		$logdata = join("", @logfile);
		$logdata =~ s/\n\n/\n<p>\n/g;
		undef @logfile;
	
		# Save the users entry for the front page
		$userid = $result[1];
		$host = $result[2];
		$timestamp = $result[3];
	
		push @entrydata, $userid, $host, $timestamp, $logdata;
		$entrydata = join("|-|", @entrydata);
		$fpentry{$timestamp} = $entrydata;
		undef @entrydata;
	}
}

# Sort the entries by time stamps
# and stuff them all  into table entries.
foreach $key (sort { $fpentry{$a} cmp $fpentry{$b}; } (keys(%fpentry))) 
{
	my ($userid, $host, $timestamp, $logdata) = split(/\|-\|/, $fpentry{$key});
	push @fplog_entries, 
		Tr( td(
			b("$userid\@$host &nbsp;&nbsp;"), $timestamp, br(), br(),
			"<blockquote>$logdata</blockquote>"
		));
}

#======================================================================
# The template files and the titles to use with each.

@templates = ( 
	"index", "help", "register", "download" 
);

@pgtitles = ( 
	"Latest Updates", "What is this?", "Registration", "Downloads" 
);



# For each template file, process it into a real HTML file with the banner
# and side navigation bar and stuff it into its appropriate directory.
$index=0;
foreach(@templates)
{
	$tmplname = $_;
	$filename = join(".", "$HTML_DIR/$_", "html");
	$filename2 = join(".", "$HTML_DIR2/$_", "html");

	# Read in the template file.
	open(FD, $filename);
	while ( <FD> )
	{
		push @template, $_;
	}
	close(FD);
	$template = join("", @template);

	# Special processing for: index.html
	if ("$tmplname" eq "index")
	{
		$data = join("\n", @fplog_entries);
		$template =~ s/\[LOGDATA\]/$data/;
	}

	# Set the default output file
	open(FD, ">$filename2");

	# Write out the new file.
	setheader(FD, $DOMAIN, "$PAGETITLE $pgtitles[$index]" );
	print FD "\n";

	print FD
		table( {-border=>"0", -width=>"100%",
			-cellpadding=>"2", -cellspacing=>"0", -nosave}, "\n",

			Tr({-valign=>"top"}, "\n",

				# The left-side navigation bar
				@navbar,

				td({-width=>"100%", -align=>"left"},

					# The content side.
					"<!-- The Content side -->\n",

					table( {-border=>"0", -bgcolor=>"#FFFFFF", -width=>"100%",
						-cellpadding=>"0", -cellspacing=>"0"},

						Tr(td(
							br({-clear=>"both"}),
							b(font({-size=>"+1"}, "BLOG:&nbsp; $pgtitles[$index]")),
							br({-clear=>"both"}),
							"<hr NOSHADE WIDTH=\"100%\">",

							$template,

						))
				
					),

					# If we add forms or buttons, they can go here.
					# br(),
					# start_form(-method=>POST, -action=>"$EXPAGE"),
					# @buttons,
					# end_form
				)
			)
		);


	print FD "\n";

	setfooter(FD);

	print FD end_html;

	close(FD);
	
	$index++;
	undef @template;
}

# Now copy over the images associated with this directory.
mkdir("$HTML_DIR2/images/$file", 0755);
opendir(DIR,"$HTML_DIR/images");
while($file = readdir(DIR))
{
	# Skip files that start with . or ..
	next if ($file =~ /^\./);

	open(FD, "$HTML_DIR/images/$file");
	while ( <FD> )
	{
		push @template, $_;
	}
	close(FD);
	open(FD, ">$HTML_DIR2/images/$file");
	print FD @template;
	close(FD);
	undef @template;
}


