#!/usr/bin/perl
#
# Display a common header for all HTML files:  Blog
#
# (c) 1999 Michael J. Hammel
#
#======================================================================
use CGI	qw/:standard :html3 :netscape/;
use Msql;


$AUTHOR = "Michael J. Hammel";
$meta     = {
	"name"    => "Author",
	"content" => "$AUTHOR"
};

# Where this project lives relative to the server top directory.
$HTML_PATH="/";
$IMAGES="/images";

# Left side bar local links list - just generic text.
$locallinks_filename = "$HTML_DIR/locallinks.txt";
open(FD, $locallinks_filename);
while ( <FD> )
{
	push @locallinks, $_;
}
close(FD);

# Left side bar features list - just generic text.
$features_filename = "$HTML_DIR/features.txt";
open(FD, $features_filename);
while ( <FD> )
{
	push @feature_list, $_;
}
close(FD);


# Navigation on the left side of the page.
push @navbar,
	td({-bgcolor=>"$leftbarbg", -width=>"$leftbarwidth"}, "\n",

		"<!-- The left side navigation bar -->\n",

		table( {-border=>0, -width=>"$leftbarwidth", -bgcolor=>"$leftbarbg",
			-cellpadding=>'0', -cellspacing=>"$leftbarsp", -nosave},
		Tr(
			td(
				@locallinks,
				font({-face=>"Arial,Helvetica", -size=>"-1"}, 
					a({-class=>"navbar", -href=>"/index.html"}, 
						b("Blog Front Page") )
				),
				br({-clear=>"both"}),
				br({-clear=>"both"}),
				font({-face=>"Arial,Helvetica", -size=>"-1"}, 
					a({-class=>"navbar", -href=>"/help.html"}, 
						b("What is this?") ),
					br({-clear=>"both"}),
					a({-class=>"navbar", -href=>"/register.html"}, 
						b("Register") ),
					br({-clear=>"both"}),
					a({-class=>"navbar", -href=>"/download.html"}, 
						b("Downloads") ),
				),
				br({-clear=>"both"}),
				br({-clear=>"both"}),
				i(font({-face=>"Arial,Helvetica"}, 
					"<u>Users:</u>"
				)),
				br({-clear=>"both"}),
				@userlist,
			) 
		),
		Tr(
			td( font({-face=>"Arial,Helvetica", -size=>"-1"},
					br({-clear=>"both"}),
					i(font({-face=>"Arial,Helvetica"}, 
						"<u>Other links:</u>"
					)),
					@feature_list
				)
			)
		),
		"\n",
		),
		"\n"
	);

# Any Javascript is passed in via the JSCRIPT global variable.
# The domain name and title to use are also passed in via the 
# $domain and $title global variables.

# CSS Styles can be passed as the last argument, but are not required.

sub setheader
{
	local ($FD, $domain, $title, $style) = @_;
	$title = join (" - ", $domain, $title);

	if ( "$style" eq "" )
	{
      # a.content:link {color: #bc6031;
      # a.content:visited {color: #894723;
      # a.navbar:visited {color: #894723; text-decoration: none;}
      # a.navbar:link {color: #ffffff; text-decoration: none;}

		$style= <<EOF;
      a.content:link {color: $clinkcolor;
            background: white;
            text-decoration: none;}
      a.content:visited {color: $cvisitedcolor;
            background: white;
            text-decoration: none;}

      a.navbar:visited {color: $nlinkcolor; text-decoration: none;}
      a.navbar:link {color: $nvisitedcolor; text-decoration: none;}
EOF
		# HEAD section
		print $FD 
			start_html(
				-meta=>$meta,
				-author=>$author,
				-title=>"$title",
				-style=>"$style",
				-bgcolor=>$bgcolor,
				-text=>$textcolor,
				-link=>$link,
				-vlink=>$vlink,
				-script=>"$JSCRIPT",
				-marginwidth=>"0",
				-marginheight=>"0",
				-topmargin=>"0",
				-leftmargin=>"0"
				);
		print $FD
			"\n",
			table( {-border=>0, -bgcolor=>"$topbarbg", -width=>"100%",
					-cellpadding=>0, -cellspacing=>0 -nosave},
		
				"\n",

				Tr( {-width=>"100%"}, 
					td( {-width=>"400"}, 
						img({-src=>"$IMAGES/$LOGO", 
							-width=>"154", -height=>"50", -border=>"0"})
					),
					td( {-width=>"25%", -align=>"right"}, 
						img({-src=>"$IMAGES/blog-banner.jpg", 
							-width=>"256", -height=>"55" -border=>"0"})
					)
				),
				"\n"
			);
		print $FD
			br({-clear=>"both"}),
			hr({-noshade=>"0" -width=>"100%"});
	}
	else
	{
		# HEAD section
		print $FD 
			start_html(
				-author=>"$author",
				-title=>"$title",
				-style=>{-src=>"$style"},
				-bgcolor=>$bgcolor,
				-text=>$textcolor,
				-link=>$link,
				-vlink=>$vlink,
				-script=>"$JSCRIPT",
				-marginwidth=>"0",
				-marginheight=>"0",
				-topmargin=>"0",
				-leftmargin=>"0"
				);
		print $FD
			"\n",
			table( {-border=>0, -bgcolor=>"$topbarbg", -width=>"100%",
					-cellpadding=>0, -cellspacing=>0 -nosave},
		
				"\n",

				Tr( {-width=>"100%"}, 
					td( {-width=>"400"}, 
						img({-src=>"$IMAGES/$LOGO", 
							-width=>"154", -height=>"50", -border=>"0"})
					),
					td( {-width=>"25%", -align=>"right"}, 
						img({-src=>"$IMAGES/blog-banner.jpg", 
							-width=>"256", -height=>"55" -border=>"0"})
					)
				),
				"\n"
			);
	}
}
sub setheader2
{
	local ($domain, $title, $style) = @_;
	$title = join (" - ", $domain, $title);

		$style= <<EOF;
      a.content:link {color: $clinkcolor;
            background: white;
            text-decoration: none;}
      a.content:visited {color: $cvisitedcolor;
            background: white;
            text-decoration: none;}

      a.navbar:visited {color: $nlinkcolor; text-decoration: none;}
      a.navbar:link {color: $nvisitedcolor; text-decoration: none;}
EOF
		# HEAD section
		print header,
			start_html(
				-meta=>$meta,
				-author=>$author,
				-title=>"$title",
				-style=>"$style",
				-bgcolor=>$bgcolor,
				-text=>$textcolor,
				-link=>$link,
				-vlink=>$vlink,
				-script=>"$JSCRIPT",
				-marginwidth=>"0",
				-marginheight=>"0",
				-topmargin=>"0",
				-leftmargin=>"0"
				);
		print 
			"\n",
			table( {-border=>0, -bgcolor=>"$topbarbg", -width=>"100%",
					-cellpadding=>0, -cellspacing=>0 -nosave},
		
				"\n",


				Tr( {-width=>"100%"}, 
					td( {-width=>"400"}, 
						img({-src=>"$IMAGES/$LOGO", 
							-width=>"198",
							-height=>"82", -border=>"0"})
					),
					td( {-width=>"25%", -align=>"right"}, 
						img({-src=>"$IMAGES/blog-banner.jpg", 
							-width=>"256", -height=>"55" -border=>"0"})
					)
				),
				"\n"
			);
		print 
			br({-clear=>"both"}),
			hr({-noshade=>"0" -width=>"100%"});
}

sub buildtitle
{
	local ($mytitle) = @_;

	push @titlebar, 
		br({-clear=>"both"}),
		b( 
			font({ -size=>"+2" }, "Blog" )
		),
		br({-clear=>"both"}),
		br({-clear=>"both"}),
		b( 
			font({ -size=>"+1" }, "$mytitle" )
		),
		br({-clear=>"both"}),
		"<hr SIZE=\"2\" WIDTH=\"100%\" NOSHADE><br>";

	return @titlebar;
}

sub setfooter
{
	local ($FD) = @_;
	
	$todaytmp =gettime();
	$today = join("/",
		substr($todaytmp, 0, 4), 
		substr($todaytmp, 4, 2), 
		substr($todaytmp, 6, 2));

	push @footer,
		hr({-noshade=>"0" -width=>"100%"}),
		br({-clear=>"both"}),
	
		font ({-face=>"Arial,Helvetica", -size=>"-1"}, 
			"$AUTHOR",
			br({-clear=>"both"}),
			"Last Updated: $today",
			br({-clear=>"both"}),
			a({-class=>"content", -href=>"mailto:$WEBMASTER\@$DOMAIN"}, 
				"$WEBMASTER\@$DOMAIN"
			),
			br({-clear=>"both"}),
			a({-class=>"content", -href=>"http://$DOMAIN"}, 
				"http://$DOMAIN"
			),
		);

	print $FD @footer;
	undef @footer;
}

1

